﻿
using PlcDataManager;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormTestWithDLL
{
    public partial class Form1 : Form
    {
        private PlcDataDriverClass plc;
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        public Form1()
        {
            log4net.Config.XmlConfigurator.Configure();
            InitializeComponent();
            plc = new PlcDataDriverClass();
            plc.ConnectionEstablished += Plc_ConnectionStatusChanged;
            plc.ChangeUpdate += Plc_ChangedNotification;

            try
            {
                log.Info("Connecting");
                plc.InitializeConnectionToPLC("MAIN", "local", 851);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void Plc_ChangedNotification(string tag, object newValue)
        {
            if (tag.ToUpper().Contains("MAIN.TESTBOOL") == true)
            {
                bool b = Convert.ToBoolean(newValue);
                Invoke(new Action(() =>
                {
                    textBox_bool.Text = b.ToString();
                }));
            }

            else if (tag.ToUpper().Contains("MAIN.TESTINT") == true)
            {
                int intData = Convert.ToInt32(newValue);
                Invoke(new Action(() =>
                {
                    textBox_int.Text = intData.ToString();
                }));
            }
            else if (tag.ToUpper().Contains("MAIN.TESTREAL") == true)
            {
                float floatData = Convert.ToSingle(newValue);
                Invoke(new Action(() =>
                {
                    textBox_real.Text = floatData.ToString();
                }));
            }
            else if (tag.ToUpper().Contains("MAIN.TESTSTRING") == true)
            {
                string stringData = Convert.ToString(newValue);
                Invoke(new Action(() =>
                {
                    textBox_string.Text = stringData;
                }));
            }
        }

        private void Plc_ConnectionStatusChanged(bool connectionStatus)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                object o = new object();
                plc.ReadValue("MAIN.testBool", ref o);
                textBox_bool.Text = o.ToString();

                o = new object();
                plc.ReadValue("MAIN.testInt", ref o);
                textBox_int.Text = o.ToString();

                o = new object();
                plc.ReadValue("MAIN.testReal", ref o);
                textBox_real.Text = o.ToString();

                o = new object();
                plc.ReadValue("MAIN.testString", ref o);
                textBox_string.Text = o.ToString();

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                object oBoolean = bool.Parse(textBox_bool.Text); ;
                plc.WriteValue("MAIN.testBool", oBoolean);


                object oo = short.Parse(textBox_int.Text); ;
                plc.WriteValue("MAIN.testInt", oo);

                object iFloatValue = float.Parse(textBox_real.Text); ;
                plc.WriteValue("MAIN.testReal", iFloatValue);

                plc.WriteValue("MAIN.testString", textBox_string.Text);

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }


    }
}
