﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TwinCAT.Ads;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        private int handleBool;
        private int handleInteger;
        private int handleReal;
        private int handleString;

        private ArrayList notificationHandles;
        private TcAdsClient adsClient;
   

        private void button1_Click(object sender, System.EventArgs e)
        {
            try
            {
                string tbBool1= adsClient.ReadAny(handleBool, typeof(Boolean)).ToString();
                textBox_bool.Text = tbBool1;
                string tbDint1 = adsClient.ReadAny(handleInteger, typeof(int)).ToString();
                textBox_int.Text = tbDint1;
                string tblreal1 = adsClient.ReadAny(handleReal, typeof(float)).ToString();
                textBox_real.Text = tblreal1;
                string tbStr1 = adsClient.ReadAny(handleString, typeof(String), new int[] { 80 }).ToString();
                textBox_string.Text = tbStr1;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void button2_Click(object sender, System.EventArgs e)
        {
            try
            {                
                bool myBool = bool.Parse(textBox_bool.Text);
                object oBoolean = myBool;
                adsClient.WriteAny(handleBool, oBoolean);

                short iValue = short.Parse(textBox_int.Text);
                object oo = iValue;
                adsClient.WriteAny(handleInteger, oo);

                float iFloat = float.Parse(textBox_real.Text);
                object iFloatValue = iFloat;
                adsClient.WriteAny(handleReal, iFloatValue);

                adsClient.WriteAny(handleString, textBox_string.Text, new int[] { 80 });
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

            private void adsClient_AdsNotificationEx(object sender, AdsNotificationExEventArgs e)
        {

            if (Convert.ToInt32(e.UserData) == handleBool)
            {
                bool b = Convert.ToBoolean(e.Value);
                Invoke(new Action(() =>
                {
                    textBox_bool.Text = b.ToString();
                }));
            }
            if (Convert.ToInt32(e.UserData) == handleInteger)
            {
                int intData = Convert.ToInt32(e.Value);
                Invoke(new Action(() =>
                {
                    textBox_int.Text = intData.ToString();
                }));
            }
            if (Convert.ToInt32(e.UserData) == handleReal)
            {
                float floatData = Convert.ToSingle(e.Value);
                Invoke(new Action(() =>
                {
                    textBox_real.Text = floatData.ToString();
                }));
            }
            if (Convert.ToInt32(e.UserData) == handleString)
            {
                string stringData = Convert.ToString(e.Value);
                Invoke(new Action(() =>
                {
                    textBox_string.Text = stringData;
                }));
            }
    }

        public Form1()
        {
            InitializeComponent();
            adsClient = new TcAdsClient();
            notificationHandles = new ArrayList();
            try
            {
                // Connect to local PLC - Runtime 1 - TwinCAT 3 Port=851
                adsClient.Connect(851);
                adsClient.AdsNotificationEx += new AdsNotificationExEventHandler(adsClient_AdsNotificationEx);

                //create handles for the PLC variables;
                handleBool = adsClient.CreateVariableHandle("MAIN.testBool");
                handleInteger = adsClient.CreateVariableHandle("MAIN.testInt");
                handleReal = adsClient.CreateVariableHandle("MAIN.testReal");
                handleString = adsClient.CreateVariableHandle("MAIN.testString");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            notificationHandles.Clear();
            try
            {
                //register notification
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.testBool", AdsTransMode.OnChange, 100, 0, handleBool, typeof(Boolean)));
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.testInt", AdsTransMode.OnChange, 100, 0, handleInteger, typeof(Int16)));
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.testReal", AdsTransMode.OnChange, 100, 0, handleReal, typeof(float)));
                notificationHandles.Add(adsClient.AddDeviceNotificationEx("MAIN.testString", AdsTransMode.OnChange, 100, 0, handleString, typeof(String), new int[] { 80 }));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
